//+------------------------------------------------------------------+
//|                                                   AllSession.mq4 |
//|                                                            Talex |
//|                                                 tan@gazinter.net |
//+------------------------------------------------------------------+
#property copyright "Talex"
#property link      "tan@gazinter.net"

//#import "kernel32.dll"
//void GetSystemTime(int& TimeArray[]);
//#import

#property indicator_chart_window

extern int    NumDays = 30;                   //  ,    
extern bool   Oceania=true;
extern color  Color_Oceania = DarkSlateGray;  //     (  )
extern bool   Asia=true;
extern color  Color_Asia = Maroon;            //     (,   -)
extern bool   Europa=true;
extern color  Color_Europa = Navy;            //     (, ,  )
extern bool   USA=true;
extern color  Color_USA = Purple;             //     (-,   -)
extern color  MaxMin = White;                 //   Max  Min
extern bool   VisioPrice=false;               //    .  min.   

extern int    DifBrokerGMT=2;                 //     GMT
int i;
datetime Newbar;

//    ()  GMT (UTC)
  
   string Open_Oceania = "21:00";         //    
   string Close_Oceania = "06:59";        //    
   string Open_Asia = "00:00";            //    
   string Close_Asia = "09:59";           //      -
   string Open_Europa = "06:00";          //    ,  
   string Close_Europa = "14:59";         //    
   string Open_USA = "13:00";             //    -
   string Close_USA = "23:59";            //    -

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {

//if(IsConnected()) DifBrokerGMT = DBGMT(); 

/*      ,     ( )
        (    ) */

   if(TimeCurrent()>StrToTime(Year()+"."+"03"+"."+SecondSundayOfMarch()) &&
      TimeCurrent()<StrToTime(Year()+"."+"03"+"."+ThirdSundayOfMarch())) {
      Open_USA=SummerTime1(Open_USA);Close_USA=SummerTime1(Close_USA); 
   }
   if(TimeCurrent()>StrToTime(Year()+"."+"04"+"."+ThirdSundayOfMarch())&&
      TimeCurrent()<StrToTime(Year()+"."+"10"+"."+LastSundayOfMarch())) {
      Open_Oceania=SummerTime1(Open_Oceania);
      Open_USA=SummerTime1(Open_USA);Close_USA=SummerTime1(Close_USA); 
   }
   if(TimeCurrent()>StrToTime(Year()+"."+"04"+"."+LastSundayOfMarch())&&
      TimeCurrent()<StrToTime(Year()+"."+"10"+"."+FirstSundayOfOctober())) {
      Open_Asia=SummerTime2(Open_Asia);Close_Asia=SummerTime2(Close_Asia);
   }
   if(TimeCurrent()>StrToTime(Year()+"."+"10"+"."+FirstSundayOfOctober())&&
      TimeCurrent()<StrToTime(Year()+"."+"10"+"."+LastSundayOfOctober())) {
      Open_Oceania=SummerTime2(Open_Oceania);
      Open_Asia=SummerTime2(Open_Asia);Close_Asia=SummerTime2(Close_Asia);
   }
   if(TimeCurrent()>StrToTime(Year()+"."+"10"+"."+LastSundayOfOctober())&&
       TimeCurrent()<StrToTime(Year()+"."+"11"+"."+FirstSundayOfNovember())) {
      Open_USA=SummerTime1(Open_USA);Close_USA=SummerTime1(Close_USA); 
   }
//      
    Open_Oceania=BrokerTime(Open_Oceania,DifBrokerGMT);
    Close_Oceania=BrokerTime(Close_Oceania,DifBrokerGMT);
    Open_Asia=BrokerTime(Open_Asia,DifBrokerGMT);
    Close_Asia=BrokerTime(Close_Asia,DifBrokerGMT);
    Open_Europa=BrokerTime(Open_Europa,DifBrokerGMT);
    Close_Europa=BrokerTime(Close_Europa,DifBrokerGMT);
    Open_USA=BrokerTime(Open_USA,DifBrokerGMT);
    Close_USA=BrokerTime(Close_USA,DifBrokerGMT);

    return;
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() {
//----
   for (i=0; i<=NumDays; i++) {
      ObjectDelete("Oceania"+i);
      ObjectDelete("Asia"+i);
      ObjectDelete("Europa"+i);
      ObjectDelete("USA"+i);
    
      ObjectDelete("Oceaniamax"+i);
      ObjectDelete("Asiamax"+i);
      ObjectDelete("Europamax"+i);
      ObjectDelete("USAmax"+i);
    
      ObjectDelete("Oceaniamin"+i);
      ObjectDelete("Asiamin"+i);
      ObjectDelete("Europamin"+i);
      ObjectDelete("USAmin"+i);
   }
//----
   return;
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {
   datetime dt=TimeCurrent();
   string stdt;
//----

   if(Newbar != Time[0]) {
      for(i=0;i<=NumDays;i++) {
         stdt=TimeToStr(dt,TIME_DATE);
         if(Oceania) {
            DrawObjects("Oceania",stdt,Open_Oceania,Close_Oceania,i);
         }
         if(Asia) {
            DrawObjects("Asia",stdt,Open_Asia,Close_Asia,i);
         }
         if(Europa) {
            DrawObjects("Europa",stdt,Open_Europa,Close_Europa,i);
         }
         if(USA) {
            DrawObjects("USA",stdt,Open_USA,Close_USA,i);
         }
         dt=PrevDate(dt);
      }
      WindowRedraw();
      Newbar = Time[0];
   }

//----
   return;
}
//+------------------------------------------------------------------+

/*-------------------------------------------------------------------+
|                     |
+-------------------------------------------------------------------*/
string SecondSundayOfMarch() {
   string SecondMarch;
   for(int i=1;i<=14;i++) {
      if(TimeDayOfWeek(StrToTime(Year()+"."+"03"+"."+i))==0) {
         SecondMarch=i;
      }
   }
   return(SecondMarch);
}

/*-------------------------------------------------------------------+
|                    |
+-------------------------------------------------------------------*/
string ThirdSundayOfMarch() {
   string ThirdMarch;
   for(int i=1;i<=21;i++) {
      if(TimeDayOfWeek(StrToTime(Year()+"."+"03"+"."+i))==0) {
         ThirdMarch=i;
      }
   }
   return(ThirdMarch);
}

/*-------------------------------------------------------------------+
|                  |
+-------------------------------------------------------------------*/
string LastSundayOfMarch() {
   string LastMarch;
   for(int i=1;i<=31;i++) {
      if(TimeDayOfWeek(StrToTime(Year()+"."+"03"+"."+i))==0)
      LastMarch=i;
   }
   return(LastMarch);
}

/*-------------------------------------------------------------------+
|                   |
+-------------------------------------------------------------------*/
string FirstSundayOfOctober() {
   string FirstOct;
   for(int i=1;i<=7;i++) {
      if(TimeDayOfWeek(StrToTime(Year()+"."+"10"+"."+i))==0)FirstOct=i;
   }
   return(FirstOct);
}

/*-------------------------------------------------------------------+
|                |
+-------------------------------------------------------------------*/
string LastSundayOfOctober() {
   string LastOct;
   for(int i=1;i<=31;i++) {
      if(TimeDayOfWeek(StrToTime(Year()+"."+"10"+"."+i))==0)LastOct=i;
   }
   return(LastOct);
}

/*-------------------------------------------------------------------+
|                    |
+-------------------------------------------------------------------*/
string FirstSundayOfNovember() {
   string FirstNovember;
   for(int i=1;i<=7;i++) {
      if(TimeDayOfWeek(StrToTime(Year()+"."+"11"+"."+i))==0)FirstNovember=i;
   }
   return(FirstNovember);
}


//-------------------------------------------------------------------+
//       ""  max. min.      +
//-------------------------------------------------------------------+
void DrawObjects(string name,string stdt,string OpenTime,string CloseTime,int i) {
   double prlow,prhigh;
   datetime ot,ct;
   color session;
  
   ot=StrToTime(stdt+" "+OpenTime);
   ct=StrToTime(stdt+" "+CloseTime);
   if(ot>ct)ct=ct+86400;
   prlow=Low[iLowest(NULL,0,MODE_LOW,iBarShift(NULL,0,ot)-iBarShift(NULL,0,ct)+1,iBarShift(NULL,0,ct))];
   prhigh=High[iHighest(NULL,0,MODE_HIGH,iBarShift(NULL,0,ot)-iBarShift(NULL,0,ct)+1,iBarShift(NULL,0,ct))];
   if(name=="Oceania") {
      if((TimeDayOfWeek(ot)==5) || (TimeDayOfWeek(ot)==6))return;
      session=Color_Oceania;
   }
   if(name=="Asia") {
      if((TimeDayOfWeek(ot)==6) || (TimeDayOfWeek(ot)==0))return;
      session=Color_Asia;
   }
   if(name=="Europa") {
      if((TimeDayOfWeek(ot)==6) || (TimeDayOfWeek(ot)==0))return;
      session=Color_Europa;
   }
   if(name=="USA") {
      if((TimeDayOfWeek(ot)==6) || (TimeDayOfWeek(ot)==0))return;
      session=Color_USA;
   }
   if(session==CLR_NONE)return;
   ObjectCreate(name+i,OBJ_RECTANGLE,0,ot,prlow,ct,prhigh);
   ObjectSet(name+i,OBJPROP_COLOR,session);
   ObjectSet(name+i,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 |OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1);
   ObjectMove(name+i,0,ot,prlow);
   ObjectMove(name+i,1,ct,prhigh);
   if(VisioPrice) {
      ObjectCreate(name+"max"+i,OBJ_TEXT,0,ot+GetTimeInterval(),prhigh+GetPriceInterval());
      ObjectSetText(name+"max"+i,DoubleToStr(prhigh,Digits),10, "Times New Roman",MaxMin);
      ObjectSet(name+"max"+i,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 |OBJ_PERIOD_M15 | OBJ_PERIOD_M30);
      ObjectMove(name+"max"+i,0,ot+GetTimeInterval(),prhigh+GetPriceInterval());
      ObjectCreate(name+"min"+i,OBJ_TEXT,0,ot+GetTimeInterval(),prlow-GetPriceInterval());
      ObjectSetText(name+"min"+i,DoubleToStr(prlow,Digits),10, "Times New Roman",MaxMin);
      ObjectSet(name+"min"+i,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 |OBJ_PERIOD_M15 | OBJ_PERIOD_M30);
      ObjectMove(name+"min"+i,0,ot+GetTimeInterval(),prlow-GetPriceInterval());
   } 
}

//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
double GetPriceInterval() {
 
   int p=Period();

   switch (p) {
      case 1:     return(Point*2);
      case 5:     return(Point*4);
      case 15:    return(Point*6);
      case 30:    return(Point*8);
      case 30:    return(Point*16);
   }
}

//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
int GetTimeInterval() {
   int p=Period();

   switch (p) {
      case 1:     return(300);
      case 5:     return(1500);
      case 15:    return(4500);
      case 30:    return(9000);
      case 30:    return(18000);
   }
}
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|                                  |
//| :                                                       |
//|   dt -                                           |
//+------------------------------------------------------------------+
datetime PrevDate (datetime dt) {
   int ty=TimeYear(dt);
   int tm=TimeMonth(dt);
   int td=TimeDay(dt);
   int th=TimeHour(dt);
   int ti=TimeMinute(dt);

   td--;
   if (td==0) {
      tm--;
      if (tm==0) {
         ty--;
         tm=12;
      }
      if (tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
      if (tm==2) if (MathMod(ty, 4)==0) td=29; else td=28;
      if (tm==4 || tm==6 || tm==9 || tm==11) td=30;
   }
   return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}

/*-----------------------------------------------------------------------+
+          #1                              +
+-----------------------------------------------------------------------*/
string SummerTime1(string WinterTime) {
   int wt,pos;
   pos=StringFind(WinterTime,":",0);
   wt=StrToInteger(StringSubstr(WinterTime,0,pos));
   wt--;
   if(wt<0)wt=23;
   if(StringSubstr(WinterTime,3,2)=="00")return(DoubleToStr(wt,0)+":00");
   if(StringSubstr(WinterTime,3,2)=="59")return(DoubleToStr(wt,0)+":59");
}

/*-----------------------------------------------------------------------+
+          #2                              +
+-----------------------------------------------------------------------*/
string SummerTime2(string WinterTime) {
   int wt,pos;
   pos=StringFind(WinterTime,":",0);
   wt=StrToInteger(StringSubstr(WinterTime,0,pos));
   wt++;
   if(wt>23)wt-=24;
   if(StringSubstr(WinterTime,3,2)=="00")return(DoubleToStr(wt,0)+":00");
   if(StringSubstr(WinterTime,3,2)=="59")return(DoubleToStr(wt,0)+":59");
}

/*-----------------------------------------------------------------------+
+                               +
+-----------------------------------------------------------------------*/
string BrokerTime(string Sessian,int DifBrokerGMT) {
   int bt,pos;
   pos=StringFind(Sessian,":",0);
   bt=StrToInteger(StringSubstr(Sessian,0,pos));
   bt+=DifBrokerGMT;
   if(bt>=24)bt-=24;
   if(bt<0)bt=24+bt;
   if(StrToInteger(StringSubstr(Sessian,pos+1,2))==0)return(DoubleToStr(bt,0)+":00");
   if(StrToInteger(StringSubstr(Sessian,pos+1,2))==59)return(DoubleToStr(bt,0)+":59");
}
/*
//+------------------------------------------------------------------+
//|   ( ) , .. UTC       |
//+------------------------------------------------------------------+
datetime UTCTime() {
   int    TimeArray[4];
   int    nYear,nMonth,nDay,nHour,nMin,nSec;    
  
   GetSystemTime(TimeArray);
//---- parse date and time from array
   nYear=TimeArray[0]&0x0000FFFF;
   nMonth=TimeArray[0]>>16;
   nDay=TimeArray[1]>>16;
   nHour=TimeArray[2]&0x0000FFFF;
   nMin=TimeArray[2]>>16;
   nSec=TimeArray[3]&0x0000FFFF;
//---- format date and time items
   string time_string=FormatDateTime(nYear,nMonth,nDay,nHour,nMin,nSec);

return(StrToTime(time_string));
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string FormatDateTime(int nYear,int nMonth,int nDay,int nHour,int nMin,int nSec) {
   string sMonth,sDay,sHour,sMin,sSec;
//----
   sMonth=100+nMonth;
   sMonth=StringSubstr(sMonth,1);
   sDay=100+nDay;
   sDay=StringSubstr(sDay,1);
   sHour=100+nHour;
   sHour=StringSubstr(sHour,1);
   sMin=100+nMin;
   sMin=StringSubstr(sMin,1);
   sSec=100+nSec;
   sSec=StringSubstr(sSec,1);
//----
   return(StringConcatenate(nYear,".",sMonth,".",sDay," ",sHour,":",sMin,":",sSec));
}
//+------------------------------------------------------------------+
double DBGMT() {
   return(MathRound((TimeCurrent() - UTCTime())/3600.));
}
*/